<?php 

include ("markdown/convert-markdown.php");


if ($_SERVER ["REQUEST_METHOD"] == "POST" ) {   
   
    $documentrecord = assignPostValuesToRecord ($_POST, $documentrecordkeys);

    $categories = array();
    if (isset ($_POST['categories'])) {
        $categories = $_POST['categories'];
    }

    //save markdown and html text to record  
    $htmlcontent = '';
    $mdarray= $newmdarray = array();
   
    if (isset ($_POST['mdarray'])) {
        $mdarray = $_POST['mdarray'];   
       
        //concatenate html sections 
        foreach ($mdarray as $id => $item) {
            if ($item !== '') {     
                      
                if ($documentrecord ['convert-to-html'] === '1') {
                    $htmlitem = convertMD($item);    
                }
                else {
                    $htmlitem = $item;
                }           
                $htmlcontent .= $htmlitem; 
                array_push ($newmdarray, $item);              
            }
        } 
    }     

    //save markdown sections delimited by dl2
    $string = implode ($dl2, $newmdarray);

    $documentrecord['md-content'] = $string;
    $documentrecord['html-content'] = $htmlcontent;       
       
    //Create new id
    $error = false;   
    $documentid = createRecordId ($documentrecord['title']); 
    //Check if id can be created       
    if ($documentid === '') {
        echo "<div class = 'error'>Unable to create record id from title</div>";
        $error = true;  
    }
    
    //Check if file already exists
    else if  (file_exists ('data/documents/' . $documentid . '.txt')) {                
        echo "<div class = 'error'>Text document already exists</div>";
        $error = true;
    }
    
    if ($error === false) {         
            
        //Date
        $documentrecord['date'] = formatDate ($documentrecord['date']);

        writeDatabaseRecord ($documentrecord, 'data/documents/' . $documentid . '.txt'); 
        removeMapEntries ('data/maps/date-document-map.txt', '', $documentid);
        addMapEntry ('data/maps/date-document-map.txt', $documentrecord['date'], $documentid);

        removeMapEntries ('data/maps/category-document-map.txt', '', $documentid);  
        foreach ($categories as $cat) {      
             addMapEntry ('data/maps/category-document-map.txt', $cat        , $documentid);
        }

    } 
}


?>
<div class = 'content-column'>
    <h2>New Document</h2>
    <form method = 'post' action = 'index.php?page=update-document' >       
       
       <label for= 'title-textarea'>Title: </label><br>   
       <textarea id = 'title-textarea' rows = '1'  name = 'title'></textarea><br><br> 

       <label for = 'date'>Date: </label><br>
       <input type = 'date' id = 'date' name = 'date' /><br><br>
        
       <?php
       //Text sections
       $mdcontent = '';
       include ('inc/edit-text-sections.php'); 
       ?>    

       <h4>Convert text to HTML?</h4>
      
        <input id = 'convert-to-html-yes' type = 'radio' name = 'convert-to-html' value = '1' checked />
        <label for  = 'convert-to-html-yes' >Yes</label> &nbsp; &nbsp;
        <input id = 'convert-to-html-no' type = 'radio' name = 'convert-to-html' value = '' />
        <label for = 'convert-to-html-no'>No</label>
       
        
        <h4>Category:</h4>
        <?php
        $selectedarray = selectmapEntries ('data/maps/category-document-map.txt','', $documentid );
        $array1 = readArray("data/categories.txt", ',');

        foreach ($array1 as $item1) {
            if (in_array ($item1, $selectedarray)) {
                echo "<input id = '" . $item1 . "-id' type = 'checkbox' name = 'categories[]' value = '" . $item1 . "' checked />";
            }
            else {
                echo "<input id = '" . $item1 . "-id' type = 'checkbox' name = 'categories[]' value = '" . $item1 . "'  />";
            }
            echo "<label for = '" . $item1 . "-id'>" . $item1 . " &nbsp; </label>";
        }
        ?>
        <br><br>
        <input type = 'submit' class = 'submitbutton' name = 'submit' value = 'Submit' />        
            
    </form> 
     <?php   
     include ('markdown/markdown-instructions.php');

     ?>
</div><div class = 'sidebar-column'> 
    <a class = 'adminbutton' href = 'index.php?page=home'>&larr; &nbsp; Home</a>
</div>
 