<?php 

include ("markdown/convert-markdown.php");

$documentid = getFromQueryString ('document');
$versionid = getFromQueryString ('version');  

if ($versionid !== '' ) { 
    $filename = 'data/document-versions/' . $versionid .  ".txt"; 
}  
else  {
    $filename = 'data/documents/' . $documentid . '.txt';	
}

$documentrecord = readDatabaseRecord($documentrecordkeys, $filename);	


if ($_SERVER ["REQUEST_METHOD"] == "POST" ) {   

    //save earlier version
    writeDatabaseRecord($documentrecord, 'data/document-versions/' . $documentid . "-" .  date ("Y-m-d-h-ia") . '.txt'); 
      
    $documentrecord = assignPostValuesToRecord ($_POST, $documentrecordkeys);

    $categories = array();
    if (isset ($_POST['categories'])) {
        $categories = $_POST['categories'];
    }
    //save markdown and html text to record  
    $htmlcontent = '';
    $mdarray= $newmdarray = array();
   
    if (isset ($_POST['md-content'])) {
       
        if ($documentrecord['convert-to-html']) {
            $documentrecord['html-content'] = convertMD ($documentrecord['md-content']);
        } 
        else {
            $documentrecord['html-content'] = $documentrecord['md-content'];
        }
    }
    else if (isset ($_POST['mdarray'])) {
        $mdarray = $_POST['mdarray'];   
       
        //concatenate html sections 
        foreach ($mdarray as $id => $item) {
            if ($item !== '') {                          
                if ($documentrecord ['convert-to-html'] === '1') {
                    $htmlitem = convertMD($item, $documentid);    
                }
                else {
                    $htmlitem = $item;
                }           
                $htmlcontent .= $htmlitem; 
                array_push ($newmdarray, $item);              
            }
        } 

        //save markdown sections delimited by dl2
        $string = implode ($dl2, $newmdarray);

        $documentrecord['md-content'] = $string;
        $documentrecord['html-content'] = $htmlcontent;
    }

    $documentrecord['date'] = formatDate ($_POST['date']);    


    
    //Create new id
    $error = false;
    if ($documentid === "") {  
        $documentid = createRecordId ($documentrecord['title']); 
        //Check if id can be created       
        if ($documentid === '') {
            echo "<div class = 'error'>Unable to create record id from title</div>";
            $error = true;  
        }
        //Check if file already exists
        else if  (file_exists ('data/documents/' . $documentid . '.txt')) {                
            echo "<div class = 'error'>Text document already exists</div>";
            $error = true;
        }
    }
    if (! $error) {
        writeDatabaseRecord ($documentrecord, 'data/documents/' . $documentid . '.txt'); 
        removeMapEntries ('data/maps/date-document-map.txt', '', $documentid);
        addMapEntry ('data/maps/date-document-map.txt', $documentrecord['date'], $documentid);

        removeMapEntries ('data/maps/category-document-map.txt', '', $documentid);  
        foreach ($categories as $cat) {      
            addMapEntry ('data/maps/category-document-map.txt', $cat        , $documentid);
        }
    }
}
?>
<div class = 'content-column'>
    <h3>Edit Document</h3>
    <?php

    if  ($versionid ) {
        echo "<b>Id: </b>" . $versionid . "<br><br>";
    }
    else {
        echo "<b>Document: </b>" . $documentrecord['title']. "<br>";
        echo "<b>Id: </b>" . $documentid . " <br>";         
    }
    ?>

<form method = 'post' action = 'index.php?page=update-document&document=<?php echo $documentid; ?>' > 
        <?php
       
        echo "<label for= 'title-textarea'>Title: </label><br> ";      
        echo "<textarea id = 'title-textarea' rows = '1'  name = 'title'>" . $documentrecord['title'] . "</textarea><br><br> ";
        
        echo "<label for = 'date'>Date: </label><br>";       
        echo "<input type = 'date' id = 'date' name = 'date' value = '" . $documentrecord['date'] . "'  /><br><br>";
      
        //Text
        if ($documentrecord['sections']) {
             $mdcontent = $documentrecord['md-content'];
             include ('inc/edit-text-sections.php');    
        }
        else {
            echo "<br><label for ='text-element' >Text </label><br>";
	        echo "<textarea id = 'text-element' class = 'textarea'  name = 'md-content'  rows = '16' >" .  $documentrecord['md-content']. "</textarea><br> "; 	
        }
        ?>    
        
        <h4>Convert text to HTML?</h4>
        <?php
        if ($documentrecord['convert-to-html'] === '1') {
            echo  "<input id = 'convert-to-html-yes' type = 'radio' name = 'convert-to-html' value = '1' checked />";
            echo "<label for 'convert-to-html-yes'>Yes</label> &nbsp; &nbsp;";
            echo  "<input id = 'convert-to-html-no' type = 'radio' name = 'convert-to-html' value = '' />";
            echo "<label for 'convert-to-html-no'>No</label>";
        }
        else {
            echo  "<input id = 'convert-to-html-yes' type = 'radio' name = 'convert-to-html' value = '1'  />";
            echo "<label for 'convert-to-html-yes'>Yes</label> &nbsp; &nbsp;";
            echo  "<input id = 'convert-to-html-no' type = 'radio' name = 'convert-to-html' value = '' checked/>";
            echo "<label for 'convert-to-html-no'>No</label>";        
        }
        ?>
        <h4>Show multiple text sections?</h4>
        <?php
        if ($documentrecord['sections'] === '1') {
            echo  "<input id = 'sections-yes' type = 'radio' name = 'sections' value = '1' checked />";
            echo "<label for 'sections-yes'>Yes</label> &nbsp; &nbsp;";
            echo  "<input id = 'sections-no' type = 'radio' name = 'sections' value = '' />";
            echo "<label for 'sections-no'>No</label>";
        }
        else {
            echo  "<input id = 'sections-yes' type = 'radio' name = 'sections' value = '1'  />";
            echo "<label for 'sections-yes'>Yes</label> &nbsp; &nbsp;";
            echo  "<input id = 'sections-no' type = 'radio' name = 'sections' value = '' checked/>";
            echo "<label for 'sections-no'>No</label>";        
        }
        ?>
        <h4>Category:</h4>
        <?php
        $selectedarray = selectmapEntries ('data/maps/category-document-map.txt','', $documentid );
        $array1 = readArray("data/categories.txt", ',');

        foreach ($array1 as $item1) {
            if (in_array ($item1, $selectedarray)) {
                echo "<input id = '" . $item1 . "-id' type = 'checkbox' name = 'categories[]' value = '" . $item1 . "' checked />";
            }
            else {
                echo "<input id = '" . $item1 . "-id' type = 'checkbox' name = 'categories[]' value = '" . $item1 . "'  />";
            }
            echo "<label for = '" . $item1 . "-id'>" . $item1 . " &nbsp; </label>";
        }
        ?>
        <h4>Styles</h4>
        <?php
       
        $array1 = scandir ('data/styles');
        foreach ($array1 as $item1) {
            if (substr ($item1, 0, 1) !== '.') {
                $style = str_replace ('.css', '', $item1);
                if ($documentrecord['style'] === $style) {
                    echo "<input id = '" . $style . "' type = 'radio' name = 'style' value = '" . $style . "'  checked >";
                    echo "<label for = '" . $style . " '>" . $style . "</label><br>";
                }
                else {
                    echo "<input id = '" . $style . "' type = 'radio' name = 'style' value = '" . $style . "'  >";
                    echo "<label for = '" . $style . " '>" . $style . "</label><br>";
                }
            }
        }
        ?>
        
        <br><br>
        <input type = 'submit' class = 'submitbutton' name = 'submit' value = 'Submit' />     
        
        <h4>Styles</h4>
       
        
            
    </form> 
     <?php   
     include ('markdown/markdown-instructions.php');
     require ('markdown/view-html.php');
     ?>
</div><div class = 'sidebar-column'>
    <?php   
    echo "<a class = 'adminbutton' href = 'index.php?page=home'>&larr; &nbsp; Home</a>";   
    echo "<a class = 'adminbutton ' href = 'index.php?page=display-document&document=" . $documentid . "'>View Document</a>";  
    echo "<a  class = 'adminbutton' target = '_blank'  href = 'index.php?page=print-document&document=" .$documentid . "&print=1'>Printable</a>";   
    echo "<a class = 'adminbutton'  href = 'index.php?page=remove-document&document=" . $documentid . "'>Remove </a>";
    echo "<a class = 'adminbutton'   href = 'index.php?page=select-previous-document&document=" . $documentid . "'>Previous Versions</a>";    
    ?>
</div>
  
<?php 

require ("inc/display-media-library.php"); 

?>  
